<?php
/**
 * Created by PhpStorm.
 * User: durong
 * Date: 2019/7/4
 * Time: 上午9:47
 */
namespace App\Http\Controllers\V1;
use App\Repositories\MusicRepository;
use App\Transformers\MusicTranformer;
use Illuminate\Http\Request;
use League\Fractal\Pagination\IlluminatePaginatorAdapter;
use League\Fractal\Resource\Collection;
use League\Fractal\Manager;
class MusicListController extends Controller
{
    public function __construct(MusicRepository $musicRepository) {
        $this->musicRepository = $musicRepository;
    }
    //热门音乐列表
    public function index(Request $request) {
        $musicList = $this->musicRepository->lists($request->all());
        $fractal = new Manager();
        $resource = new Collection($musicList, new MusicTranformer());
        $resource->setPaginator(new IlluminatePaginatorAdapter($musicList));
        $data = $fractal->createData($resource)->toArray();
        return jsonSuccess($data);
    }
}