<?php
/**
 * Created by PhpStorm.
 * User: durong
 * Date: 2019/7/4
 * Time: 上午9:50
 */
namespace App\Repositories;

use App\Models\PostMusicCategoryRel;
use Illuminate\Support\Facades\Cache;

class MusicRepository
{
    public function __construct(PostMusicCategoryRel $postMusicCategoryRel)
    {
        $this->postMusicCategoryRel = $postMusicCategoryRel;
    }

    //热门音乐列表
    public function lists($request)
    {
        $perPage = isset($request['per_page']) ? $request['per_page'] : 20;
        $music_key = config('constants.MUSIC_LIST');
        if (Cache::has($music_key)) {
            return Cache::store('redis')->get($music_key);
        }

        $category_name = '热门';
        $postMusicCategoryRel = $this->postMusicCategoryRel
            ->join('post_music_category', 'post_music_category.id', '=', 'post_music_category_rel.music_category_id')
            ->join('post_music', 'post_music.id', '=', 'post_music_category_rel.mid')
            ->select('post_music.*')
            ->where('post_music_category.name', 'like', "%{$category_name}%")
            ->orderBy('id', 'desc')
            ->paginate($perPage);

        if (!Cache::has($music_key)) {
            Cache::store('redis')->put($music_key, $postMusicCategoryRel, 604800);//一周过期
        }

        return $postMusicCategoryRel;
    }


}